#! /usr/bin/perl
#
#--------------------------------------------------------------
# This code is used for calculating the number of binding residues, non-binding residues and all residues from RNA_T dataset
# Before running this code, you need install perl
# In our experiment, perl V5.18.2 64bit is tested
#--------------------------------------------------------------
# Written by Jian Zhang (Email:jzhang6@vcu.edu)
# Please contact jzhang6@vcu.edu if you have any problems.
#--------------------------------------------------------------
$bindingResidues=0;
$nonbindingResidues=0;
$Residues=0;


open READ,"RNA_T.txt" or die "Could not open file.\n";
chomp(@array=<READ>);
close READ;

for($cn=0;$cn<@array;){

	@callen=split(//,@array[$cn+1]);
	$length=0;
	for($iteration=0;$iteration<@callen;$iteration++){
		if(@callen[$iteration] =~ /[A-Z]/){
			$length=$length+1;
		}
	}

	@RES=split(//,$array[$cn+2]);#PDB residues
	@RNA=split(//,$array[$cn+3]);#RNA-binding residues

	for($cm=0;$cm<$length;$cm++){
		if($RES[$cm] =~ /A|R|N|D|C|E|Q|G|H|I|L|K|M|F|P|S|T|W|Y|V/){
			$Residues=$Residues+1;
			if($RNA[$cm] !~ /A|R|N|D|C|E|Q|G|H|I|L|K|M|F|P|S|T|W|Y|V/){
				$nonbindingResidues=$nonbindingResidues+1;
			}
			if($RNA[$cm] =~ /A|R|N|D|C|E|Q|G|H|I|L|K|M|F|P|S|T|W|Y|V/){
				$bindingResidues=$bindingResidues+1;
			}
		}
	}

	$cn=$cn+4;
}

open LOG,">>datasets.log";
print LOG "RNA\n";
print LOG "Binding: ".$bindingResidues."\n";
print LOG "Nonbinding: ".$nonbindingResidues."\n";
print LOG "Total: ".$Residues."\n";
close LOG;

